Index: /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_maexxna.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_maexxna.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_maexxna.cpp (revision 260)
@@ -238,9 +238,9 @@
     newscript->Name="boss_maexxna";
     newscript->GetAI = GetAI_boss_maexxna;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_webwrap";
     newscript->GetAI = GetAI_mob_webwrap;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_sapphiron.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_sapphiron.cpp (revision 158)
+++ /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_sapphiron.cpp (revision 260)
@@ -196,4 +196,4 @@
     newscript->Name="boss_sapphiron";
     newscript->GetAI = GetAI_boss_sapphiron;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_razuvious.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_razuvious.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/naxxramas/boss_razuvious.cpp (revision 260)
@@ -164,4 +164,4 @@
     newscript->Name="boss_razuvious";
     newscript->GetAI = GetAI_boss_razuvious;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/instance_magisters_terrace.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/instance_magisters_terrace.cpp (revision 137)
+++ /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/instance_magisters_terrace.cpp (revision 260)
@@ -250,4 +250,4 @@
     newscript->Name = "instance_magisters_terrace";
     newscript->GetInstanceData = GetInstanceData_instance_magisters_terrace;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_felblood_kaelthas.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_felblood_kaelthas.cpp (revision 257)
+++ /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_felblood_kaelthas.cpp (revision 260)
@@ -762,34 +762,34 @@
     newscript->Name = "boss_felblood_kaelthas";
     newscript->GetAI = GetAI_boss_felblood_kaelthas;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name = "mob_arcane_sphere";
     newscript->GetAI = GetAI_mob_arcane_sphere;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_felkael_phoenix";
     newscript->GetAI = GetAI_mob_felkael_phoenix;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_felkael_phoenix_egg";
     newscript->GetAI = GetAI_mob_felkael_phoenix_egg;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_felkael_flamestrike";
     newscript->GetAI = GetAI_mob_felkael_flamestrike;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
 	newscript = new Script;
     newscript->Name="go_kael_orb";
     newscript->pGOHello = &GOHello_go_kael_orb;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
 	newscript = new Script;
     newscript->Name="go_movie_orb";
     newscript->pGOHello = &GOHello_go_movie_orb;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_selin_fireheart.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_selin_fireheart.cpp (revision 137)
+++ /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_selin_fireheart.cpp (revision 260)
@@ -404,9 +404,9 @@
     newscript->Name="boss_selin_fireheart";
     newscript->GetAI = GetAI_boss_selin_fireheart;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_fel_crystal";
     newscript->GetAI = GetAI_mob_fel_crystal;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_vexallus.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_vexallus.cpp (revision 137)
+++ /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_vexallus.cpp (revision 260)
@@ -239,9 +239,9 @@
     newscript->Name="boss_vexallus";
     newscript->GetAI = GetAI_boss_vexallus;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="mob_pure_energy";
     newscript->GetAI = GetAI_mob_pure_energy;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_priestess_delrissa.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_priestess_delrissa.cpp (revision 137)
+++ /trunk/src/bindings/scripts/scripts/zone/magisters_terrace/boss_priestess_delrissa.cpp (revision 260)
@@ -1356,59 +1356,59 @@
     newscript->Name="boss_priestess_delrissa";
     newscript->GetAI = GetAI_boss_priestess_delrissa;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_kagani_nightstrike";
     newscript->GetAI = GetAI_boss_kagani_nightstrike;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_ellris_duskhallow";
     newscript->GetAI = GetAI_ellris_duskhallow;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_eramas_brightblaze";
     newscript->GetAI = GetAI_eramas_brightblaze;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_yazzai";
     newscript->GetAI = GetAI_yazzai;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_warlord_salaris";
     newscript->GetAI = GetAI_warlord_salaris;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_garaxxas";
     newscript->GetAI = GetAI_garaxxas;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_apoko";
     newscript->GetAI = GetAI_apoko;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="boss_zelfan";
     newscript->GetAI = GetAI_zelfan;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     /*newscript = new Script;
     newscript->Name="mob_high_explosive_sheep";
     newscript->GetAI = GetAI_mob_high_explosive_sheep;
-    m_scripts[nrscripts++] = newscript;*/
+    newscript->RegisterSelf();*/
 
     /*newscript = new Script;
     newscript->Name="mob_fizzle";
     newscript->GetAI = GetAI_mob_fizzle;
-    m_scripts[nrscripts++] = newscript;*/
+    newscript->RegisterSelf();*/
 
     /*newscript = new Script;
     newscript->Name="mob_sliver";
     newscript->GetAI = GetAI_mob_sliver;
-    m_scripts[nrscripts++] = newscript;*/
+    newscript->RegisterSelf();*/
 }
Index: /trunk/src/bindings/scripts/scripts/zone/silithus/silithus.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/silithus/silithus.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/silithus/silithus.cpp (revision 260)
@@ -146,4 +146,4 @@
     newscript->pGossipHello =   &GossipHello_npcs_rutgar_and_frankal;
     newscript->pGossipSelect =  &GossipSelect_npcs_rutgar_and_frankal;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_landslide.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_landslide.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_landslide.cpp (revision 260)
@@ -91,4 +91,4 @@
     newscript->Name="boss_landslide";
     newscript->GetAI = GetAI_boss_landslide;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_noxxion.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_noxxion.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_noxxion.cpp (revision 260)
@@ -146,4 +146,4 @@
     newscript->Name="boss_noxxion";
     newscript->GetAI = GetAI_boss_noxxion;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_princess_theradras.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_princess_theradras.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_princess_theradras.cpp (revision 260)
@@ -105,4 +105,4 @@
     newscript->Name="boss_princess_theradras";
     newscript->GetAI = GetAI_boss_ptheradras;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_celebras_the_cursed.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_celebras_the_cursed.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/maraudon/boss_celebras_the_cursed.cpp (revision 260)
@@ -94,4 +94,4 @@
     newscript->Name="celebras_the_cursed";
     newscript->GetAI = GetAI_celebras_the_cursed;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/hellfire_peninsula/boss_doomlord_kazzak.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/hellfire_peninsula/boss_doomlord_kazzak.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/hellfire_peninsula/boss_doomlord_kazzak.cpp (revision 260)
@@ -138,4 +138,4 @@
     newscript->Name="boss_doomlord_kazzak";
     newscript->GetAI = GetAI_boss_doomlordkazzak;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/hellfire_peninsula/hellfire_peninsula.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/hellfire_peninsula/hellfire_peninsula.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/hellfire_peninsula/hellfire_peninsula.cpp (revision 260)
@@ -172,5 +172,5 @@
     newscript->pGossipHello =   &GossipHello_npc_wing_commander_dabiree;
     newscript->pGossipSelect =  &GossipSelect_npc_wing_commander_dabiree;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -178,5 +178,5 @@
     newscript->pGossipHello =   &GossipHello_npc_gryphoneer_windbellow;
     newscript->pGossipSelect =  &GossipSelect_npc_gryphoneer_windbellow;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
@@ -184,4 +184,4 @@
     newscript->pGossipHello =   &GossipHello_npc_wing_commander_brack;
     newscript->pGossipSelect =  &GossipSelect_npc_wing_commander_brack;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/mulgore/mulgore.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/mulgore/mulgore.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/mulgore/mulgore.cpp (revision 260)
@@ -61,4 +61,4 @@
     newscript->pGossipHello          = &GossipHello_npc_skorn_whitecloud;
     newscript->pGossipSelect         = &GossipSelect_npc_skorn_whitecloud;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/zone/feralas/feralas.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/zone/feralas/feralas.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/zone/feralas/feralas.cpp (revision 260)
@@ -77,9 +77,9 @@
     newscript->pGossipHello = &GossipHello_npc_gregan_brewspewer;
     newscript->pGossipSelect = &GossipSelect_npc_gregan_brewspewer;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="npc_screecher_spirit";
     newscript->pGossipHello = &GossipHello_npc_screecher_spirit;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/areatrigger/areatrigger_scripts.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/areatrigger/areatrigger_scripts.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/areatrigger/areatrigger_scripts.cpp (revision 260)
@@ -41,4 +41,4 @@
     newscript->Name="at_test";
     newscript->pAreaTrigger = ATtest;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/scripts/item/item_scripts.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/item/item_scripts.cpp (revision 105)
+++ /trunk/src/bindings/scripts/scripts/item/item_scripts.cpp (revision 260)
@@ -456,94 +456,94 @@
     newscript->Name="item_area_52_special";
     newscript->pItemUse = ItemUse_item_area_52_special;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_arcane_charges";
     newscript->pItemUse = ItemUse_item_arcane_charges;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_attuned_crystal_cores";
     newscript->pItemUse = ItemUse_item_attuned_crystal_cores;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_blackwhelp_net";
     newscript->pItemUse = ItemUse_item_blackwhelp_net;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_disciplinary_rod";
     newscript->pItemUse = ItemUse_item_disciplinary_rod;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_draenei_fishing_net";
     newscript->pItemUse = ItemUse_item_draenei_fishing_net;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_nether_wraith_beacon";
     newscript->pItemUse = ItemUse_item_nether_wraith_beacon;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_flying_machine";
     newscript->pItemUse = ItemUse_item_flying_machine;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_gor_dreks_ointment";
     newscript->pItemUse = ItemUse_item_gor_dreks_ointment;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_muiseks_vessel";
     newscript->pItemUse = ItemUse_item_muiseks_vessel;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_razorthorn_flayer_gland";
     newscript->pItemUse = ItemUse_item_razorthorn_flayer_gland;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_tame_beast_rods";
     newscript->pItemUse = ItemUse_item_tame_beast_rods;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_protovoltaic_magneto_collector";
     newscript->pItemUse = ItemUse_item_protovoltaic_magneto_collector;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_soul_cannon";
     newscript->pItemUse = ItemUse_item_soul_cannon;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_sparrowhawk_net";
     newscript->pItemUse = ItemUse_item_sparrowhawk_net;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_voodoo_charm";
     newscript->pItemUse = ItemUse_item_voodoo_charm;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_vorenthals_presence";
     newscript->pItemUse = ItemUse_item_vorenthals_presence;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_yehkinyas_bramble";
     newscript->pItemUse = ItemUse_item_yehkinyas_bramble;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 
     newscript = new Script;
     newscript->Name="item_zezzaks_shard";
     newscript->pItemUse = ItemUse_item_zezzak_shard;
-    m_scripts[nrscripts++] = newscript;
-}
+    newscript->RegisterSelf();
+}
Index: /trunk/src/bindings/scripts/scripts/item/item_test.cpp
===================================================================
--- /trunk/src/bindings/scripts/scripts/item/item_test.cpp (revision 90)
+++ /trunk/src/bindings/scripts/scripts/item/item_test.cpp (revision 260)
@@ -39,4 +39,4 @@
     newscript->Name="item_test";
     newscript->pItemUse = ItemUse_item_test;
-    m_scripts[nrscripts++] = newscript;
+    newscript->RegisterSelf();
 }
Index: /trunk/src/bindings/scripts/ScriptMgr.cpp
===================================================================
--- /trunk/src/bindings/scripts/ScriptMgr.cpp (revision 223)
+++ /trunk/src/bindings/scripts/ScriptMgr.cpp (revision 260)
@@ -18,5 +18,6 @@
 
 //*** Global data ***
-int nrscripts;
+int num_db_scripts;
+int num_sc_scripts;
 Script *m_scripts[MAX_SCRIPTS];
 
@@ -47,5 +48,4 @@
 // Text Maps
 UNORDERED_MAP<int32, StringTextData> TextMap;
-
 
 //*** End Global data ***
@@ -1181,13 +1181,14 @@
 TRINITY_DLL_EXPORT
 void ScriptsFree()
-{   
+{
     // Free Spell Summary
     delete []SpellSummary;
 
     // Free resources before library unload
-    for(int i=0;i<nrscripts;i++)
+    for(int i=0;i<num_db_scripts;i++)
         delete m_scripts[i];
 
-    nrscripts = 0;
+    num_db_scripts = 0;
+    num_sc_scripts = 0;
 }
 
@@ -1240,4 +1241,6 @@
         LoadDatabase();
 
+    num_db_scripts = GetScriptNames().size();
+
     outstring_log("TSCR: Loading C++ scripts");
     barGoLink bar(1);
@@ -1245,5 +1248,4 @@
     outstring_log("");
 
-    nrscripts = 0;
     for(int i=0;i<MAX_SCRIPTS;i++)
         m_scripts[i]=NULL;
@@ -1776,6 +1778,5 @@
     // -------------------
 
-    outstring_log("TSCR: Loaded %u C++ Scripts", nrscripts);
-    outstring_log("");
+    outstring_log(">> Loaded %i C++ Scripts (of %i ScriptNames defined in Mangos database)", num_sc_scripts, num_db_scripts);
 }
 
@@ -1849,21 +1850,13 @@
 //*** Functions used internally ***
 
-TRINITY_DLL_EXPORT
-char const* ScriptsVersion()
-{
-	return "Default Trinity scripting library";
-}
-
-Script* GetScriptByName(std::string Name)
-{
-    if (Name.empty())
-        return NULL;
-
-    for(int i=0;i<MAX_SCRIPTS;i++)
-    {
-        if (m_scripts[i] && m_scripts[i]->Name == Name)
-            return m_scripts[i];
-    }
-    return NULL;
+void Script::RegisterSelf()
+{
+    int id = GetScriptId(Name.c_str());
+    if (id != 0)
+    {
+        m_scripts[id] = this;
+        ++num_sc_scripts;
+    } else
+        debug_log("SD2: RegisterSelf, but script named %s does not have ScriptName assigned in database.",(this)->Name.c_str());
 }
 
@@ -1872,7 +1865,12 @@
 
 TRINITY_DLL_EXPORT
+char const* ScriptsVersion()
+{
+	return "Default Trinity scripting library";
+}
+TRINITY_DLL_EXPORT
 bool GossipHello ( Player * player, Creature *_Creature )
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pGossipHello) return false;
 
@@ -1886,5 +1884,5 @@
     debug_log("TSCR: Gossip selection, sender: %d, action: %d",sender, action);
 
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pGossipSelect) return false;
 
@@ -1898,5 +1896,5 @@
     debug_log("TSCR: Gossip selection with code, sender: %d, action: %d",sender, action);
 
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pGossipSelectWithCode) return false;
 
@@ -1908,5 +1906,5 @@
 bool QuestAccept( Player *player, Creature *_Creature, Quest const *_Quest )
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pQuestAccept) return false;
 
@@ -1918,5 +1916,5 @@
 bool QuestSelect( Player *player, Creature *_Creature, Quest const *_Quest )
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pQuestSelect) return false;
 
@@ -1928,5 +1926,5 @@
 bool QuestComplete( Player *player, Creature *_Creature, Quest const *_Quest )
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pQuestComplete) return false;
 
@@ -1938,5 +1936,5 @@
 bool ChooseReward( Player *player, Creature *_Creature, Quest const *_Quest, uint32 opt )
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pChooseReward) return false;
 
@@ -1948,5 +1946,5 @@
 uint32 NPCDialogStatus( Player *player, Creature *_Creature )
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pNPCDialogStatus) return 100;
 
@@ -1958,6 +1956,6 @@
 uint32 GODialogStatus( Player *player, GameObject *_GO )
 {
-    Script *tmpscript = GetScriptByName(_GO->GetGOInfo()->ScriptName);
-    if(!tmpscript || !tmpscript->pGODialogStatus) return 100;
+    Script *tmpscript = m_scripts[_GO->GetGOInfo()->ScriptId];
+    if (!tmpscript || !tmpscript->pGODialogStatus) return 100;
 
     player->PlayerTalkClass->ClearMenus();
@@ -1968,5 +1966,5 @@
 bool ItemHello( Player *player, Item *_Item, Quest const *_Quest )
 {
-    Script *tmpscript = GetScriptByName(_Item->GetProto()->ScriptName);
+    Script *tmpscript = m_scripts[_Item->GetProto()->ScriptId];
     if (!tmpscript || !tmpscript->pItemHello) return false;
 
@@ -1978,5 +1976,5 @@
 bool ItemQuestAccept( Player *player, Item *_Item, Quest const *_Quest )
 {
-    Script *tmpscript = GetScriptByName(_Item->GetProto()->ScriptName);
+    Script *tmpscript = m_scripts[_Item->GetProto()->ScriptId];
     if (!tmpscript || !tmpscript->pItemQuestAccept) return false;
 
@@ -1988,5 +1986,5 @@
 bool GOHello( Player *player, GameObject *_GO )
 {
-    Script *tmpscript = GetScriptByName(_GO->GetGOInfo()->ScriptName);
+    Script *tmpscript = m_scripts[_GO->GetGOInfo()->ScriptId];
     if (!tmpscript || !tmpscript->pGOHello) return false;
 
@@ -1998,5 +1996,5 @@
 bool GOQuestAccept( Player *player, GameObject *_GO, Quest const *_Quest )
 {
-    Script *tmpscript = GetScriptByName(_GO->GetGOInfo()->ScriptName);
+    Script *tmpscript = m_scripts[_GO->GetGOInfo()->ScriptId];
     if (!tmpscript || !tmpscript->pGOQuestAccept) return false;
 
@@ -2008,5 +2006,5 @@
 bool GOChooseReward( Player *player, GameObject *_GO, Quest const *_Quest, uint32 opt )
 {
-    Script *tmpscript = GetScriptByName(_GO->GetGOInfo()->ScriptName);
+    Script *tmpscript = m_scripts[_GO->GetGOInfo()->ScriptId];
     if (!tmpscript || !tmpscript->pGOChooseReward) return false;
 
@@ -2018,7 +2016,5 @@
 bool AreaTrigger( Player *player, AreaTriggerEntry * atEntry)
 {
-    Script *tmpscript = NULL;
-
-    tmpscript = GetScriptByName(GetAreaTriggerScriptNameById(atEntry->id));
+    Script *tmpscript = m_scripts[GetAreaTriggerScriptId(atEntry->id)];
     if (!tmpscript || !tmpscript->pAreaTrigger) return false;
 
@@ -2029,7 +2025,7 @@
 CreatureAI* GetAI(Creature *_Creature)
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
-
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->GetAI) return NULL;
+
     return tmpscript->GetAI(_Creature);
 }
@@ -2038,5 +2034,5 @@
 bool ItemUse( Player *player, Item* _Item, SpellCastTargets const& targets)
 {
-    Script *tmpscript = GetScriptByName(_Item->GetProto()->ScriptName);
+    Script *tmpscript = m_scripts[_Item->GetProto()->ScriptId];
     if (!tmpscript || !tmpscript->pItemUse) return false;
 
@@ -2047,5 +2043,5 @@
 bool ReceiveEmote( Player *player, Creature *_Creature, uint32 emote )
 {
-    Script *tmpscript = GetScriptByName(_Creature->GetScriptName());
+    Script *tmpscript = m_scripts[_Creature->GetScriptId()];
     if (!tmpscript || !tmpscript->pReceiveEmote) return false;
 
@@ -2056,10 +2052,8 @@
 InstanceData* CreateInstanceData(Map *map)
 {
-    Script *tmpscript = NULL;
-
-    if (!map->IsDungeon()) return false;
-
-    tmpscript = GetScriptByName(((InstanceMap*)map)->GetScript());
-    if (!tmpscript || !tmpscript->GetInstanceData) return false;
+    if (!map->IsDungeon()) return NULL;
+
+    Script *tmpscript = m_scripts[((InstanceMap*)map)->GetScriptId()];
+    if (!tmpscript || !tmpscript->GetInstanceData) return NULL;
 
     return tmpscript->GetInstanceData(map);
Index: /trunk/sql/updates/262_realmd.sql
===================================================================
--- /trunk/sql/updates/262_realmd.sql (revision 260)
+++ /trunk/sql/updates/262_realmd.sql (revision 260)
@@ -0,0 +1,2 @@
+ALTER TABLE `account`
+  CHANGE COLUMN  `email` `email` text;
Index: /trunk/sql/updates/262_world_runthisonlyonce.sql
===================================================================
--- /trunk/sql/updates/262_world_runthisonlyonce.sql (revision 260)
+++ /trunk/sql/updates/262_world_runthisonlyonce.sql (revision 260)
@@ -0,0 +1,31 @@
+ALTER TABLE event_scripts
+  DROP datatext,
+  ADD COLUMN dataint int(11) NOT NULL default '0' AFTER datalong2; 
+
+ALTER TABLE gameobject_scripts
+  DROP datatext,
+  ADD COLUMN dataint int(11) NOT NULL default '0' AFTER datalong2; 
+
+ALTER TABLE quest_end_scripts
+  DROP datatext,
+  ADD COLUMN dataint int(11) NOT NULL default '0' AFTER datalong2; 
+
+ALTER TABLE quest_start_scripts
+  DROP datatext,
+  ADD COLUMN dataint int(11) NOT NULL default '0' AFTER datalong2; 
+
+ALTER TABLE spell_scripts
+  DROP datatext,
+  ADD COLUMN dataint int(11) NOT NULL default '0' AFTER datalong2; 
+
+ALTER TABLE creature_movement
+  DROP `text1`,
+  DROP `text2`,
+  DROP `text3`,
+  DROP `text4`,
+  DROP `text5`,
+  ADD COLUMN textid1 int(11) NOT NULL default '0' AFTER waittime,
+  ADD COLUMN textid2 int(11) NOT NULL default '0' AFTER textid1,
+  ADD COLUMN textid3 int(11) NOT NULL default '0' AFTER textid2,
+  ADD COLUMN textid4 int(11) NOT NULL default '0' AFTER textid3,
+  ADD COLUMN textid5 int(11) NOT NULL default '0' AFTER textid4;
Index: /trunk/sql/updates/262_characters.sql
===================================================================
--- /trunk/sql/updates/262_characters.sql (revision 260)
+++ /trunk/sql/updates/262_characters.sql (revision 260)
@@ -0,0 +1,5 @@
+ALTER TABLE `guild_bank_tab`
+  CHANGE COLUMN `TabText` `TabText` text;
+
+ALTER TABLE `character_aura` ADD `stackcount` INT NOT NULL DEFAULT '1' AFTER `effect_index` ;
+ALTER TABLE `pet_aura` ADD `stackcount` INT NOT NULL DEFAULT '1' AFTER `effect_index` ;
